/*
 * $Id: prefmng.c,v 1.1.1.1 2002/05/04 09:19:09 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Handle preference in ram0.
 *
 * @version $Revision: 1.1.1.1 $
 */
#include <fcntl.h>

#include "putipati.h"

/* preference data file */
#define PREFERENCES_FILE "/ram0/ptptpref.dat"
#define PREFERENCES_FILE_INFO "Putipati pref"

Boolean loadPreferences(char far *prefData, int size) {
  int prefFd;
  struct stat statbuf; 
  if(stat(PREFERENCES_FILE, &statbuf) == E_FS_FILE_NOT_FOUND) {
    return FALSE;
  }
  if((prefFd = open(PREFERENCES_FILE, O_RDWR, 0)) < 0) { 
    return FALSE;
  }
  lseek(prefFd, 0, 0);
  read(prefFd, prefData, size);
  close(prefFd);
  return TRUE;
}
    
Boolean savePreferences(char far *prefData, int size) {
  int prefFd;
  struct stat statbuf; 
  if(stat(PREFERENCES_FILE, &statbuf) == E_FS_FILE_NOT_FOUND) { 
    if(creat(PREFERENCES_FILE, FMODE_W|FMODE_R, (size/128)+1) != E_FS_SUCCESS) { 
      return FALSE;
    }
    fs_setinfo(PREFERENCES_FILE, PREFERENCES_FILE_INFO);
  }
  if((prefFd = open(PREFERENCES_FILE, O_RDWR, 0)) < 0) { 
    return FALSE;
  }
  lseek(prefFd, 0, 0); 
  write(prefFd, prefData, size);
  close(prefFd);
  return TRUE;
}
